#!/usr/bin/env python

from collections import defaultdict

def powerset(seq):
	return reduce(lambda result, x: result + [subset + [x] for subset in result],
                  seq, [[]])

def get_inc_subseq(arr):
	if len(arr) <= 1:
		return arr
	subseq = [arr[0]]
	for x in range(1, len(arr)):
		if arr[x] > subseq[x-1]:
			subseq.append(arr[x])
		else:
			break
	return subseq
			
if __name__ == "__main__":
	gen = powerset([0, 8, 4, 12, 2, 10, 6, 14, 1, 9, 5, 13, 3, 11, 7, 15])
	possible_seq = defaultdict(list)
	for i in gen:
		subseq = get_inc_subseq(i)
		possible_seq[len(subseq)].append(subseq)
	max_len = sorted(possible_seq, reverse=True)[0]
	print "Possible increasing subsequences are ::"
	for i in possible_seq[max_len]:
		print i